import { __decorate } from 'tslib';
import { EventEmitter, ɵɵdefineInjectable, Output, Injectable, Component, ElementRef, Input, Directive, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';

let NgxCopilotService = class NgxCopilotService {
    constructor() {
        this.template = new EventEmitter();
        this.nextEmit = new EventEmitter();
        this.getParent = () => {
            try {
                const wrapper = document.querySelector(`.ngx-wrapper-overview`);
                wrapper.style.display = 'block';
                const copilotsElement = document.querySelectorAll(`.ngx-copilot-init`);
                Array.from(copilotsElement).map(e => {
                    const order = e.getAttribute('data-step');
                    if (order) {
                        this.find(order);
                        const el = e.getBoundingClientRect();
                        const single = document.querySelector(`.copilot-view-step-${order}`);
                        const { top, right, left, bottom, width } = el;
                        single.style.marginLeft = `${width}px`;
                        single.style.top = `${top}px`;
                        single.style.right = `${right}px`;
                        single.style.bottom = `${bottom}px`;
                        single.style.left = `${left}px`;
                    }
                });
            }
            catch (e) {
                return null;
            }
        };
        this.getTemplates = () => {
            try {
                this.elementsDomActive = document.querySelectorAll(`.copilot-view.copilot-active`);
                this.elementsDom = document.querySelectorAll(`.copilot-view`);
                if (!(this.elementsDomActive.length)) {
                    this.find(1);
                }
            }
            catch (e) {
                return null;
            }
        };
        this.checkInit = () => {
            setTimeout(() => {
                this.getParent();
                this.getTemplates();
            }, 60);
        };
        this.removeWrapper = () => {
            try {
                const body = document.querySelector(`body`);
                const wrapper = document.querySelector(`.ngx-wrapper-overview`);
                const list = document.querySelector(`.copilot-view`);
                const listParent = document.querySelectorAll(`.ngx-copilot-init`);
                Array.from(listParent).map((e) => {
                    console.log(e);
                    e.style.backgroundColor = 'initial';
                });
                Array.from(list).map((e) => {
                    e.style.display = `none`;
                });
                body.classList.remove('ngx-copilot-active');
                wrapper.style.display = 'none';
            }
            catch (e) {
                return null;
            }
        };
        this.find = (order = null) => {
            try {
                const wrapper = document.querySelector(`body`);
                Array.from(this.elementsDom).map((e) => {
                    const o = e.getAttribute('step');
                    const single = document.querySelector(`.ngx-copilot-init[data-step='${o}']`);
                    if (`${order}` === o) {
                        single.style.backgroundColor = '#cfceff';
                        single.classList.add('ngx-copilot-pulse');
                        wrapper.classList.add('ngx-copilot-active');
                        wrapper.classList.add(`ngx-copilot-active-step-${o}`);
                        e.style.display = `block`;
                    }
                    else {
                        wrapper.classList.remove(`ngx-copilot-active-step-${o}`);
                        single.style.backgroundColor = 'initial';
                        single.classList.remove('ngx-copilot-pulse');
                        // wrapper.classList.remove('ngx-copilot-active')
                        e.style.display = `none`;
                    }
                });
            }
            catch (e) {
                return null;
            }
        };
        this.next = (data = null) => {
            this.nextEmit.emit(data);
        };
    }
};
NgxCopilotService.ɵprov = ɵɵdefineInjectable({ factory: function NgxCopilotService_Factory() { return new NgxCopilotService(); }, token: NgxCopilotService, providedIn: "root" });
__decorate([
    Output()
], NgxCopilotService.prototype, "template", void 0);
__decorate([
    Output()
], NgxCopilotService.prototype, "nextEmit", void 0);
NgxCopilotService = __decorate([
    Injectable({
        providedIn: 'root'
    })
], NgxCopilotService);

let NgxCopilotComponent = class NgxCopilotComponent {
    constructor() { }
    ngOnInit() {
    }
};
NgxCopilotComponent = __decorate([
    Component({
        selector: 'lib-ngx-copilot',
        template: `
    <p>
      ngx-copilot works!
    </p>
  `
    })
], NgxCopilotComponent);

let CopilotDirective = class CopilotDirective {
    constructor(service, elem) {
        this.service = service;
        this.elem = elem;
    }
    ngOnInit() {
    }
    ngOnDestroy() {
        this.service.template.unsubscribe();
    }
    ngAfterViewInit() {
        if (this.template) {
            this.elem.nativeElement.classList.add('ngx-copilot-init');
            if (this.step) {
                this.elem.nativeElement.dataset.step = this.step;
                this.service.template.emit({
                    step: this.step,
                    template: this.template
                });
            }
        }
    }
};
CopilotDirective.ctorParameters = () => [
    { type: NgxCopilotService },
    { type: ElementRef }
];
__decorate([
    Input('copilot-step')
], CopilotDirective.prototype, "step", void 0);
__decorate([
    Input('copilot-template')
], CopilotDirective.prototype, "template", void 0);
CopilotDirective = __decorate([
    Directive({
        selector: '[copilot]'
    })
], CopilotDirective);

let NgxWrapperCopilotComponent = class NgxWrapperCopilotComponent {
    constructor(service) {
        this.service = service;
        this.viewTemplate = [];
    }
    ngOnInit() {
        this.service.template.subscribe(a => {
            this.viewTemplate.push(a);
        });
        this.service.nextEmit.subscribe(next => this.service.find(next));
    }
    ngAfterViewInit() {
        setTimeout(() => {
        }, 50);
    }
};
NgxWrapperCopilotComponent.ctorParameters = () => [
    { type: NgxCopilotService }
];
NgxWrapperCopilotComponent = __decorate([
    Component({
        selector: 'ngx-wrapper-copilot',
        template: "<div class=\"ngx-wrapper-overview animate__animated animate__fadeIn\">\n  <div *ngFor=\"let te of viewTemplate\" [attr.step]=\"te?.step\"\n       class=\"animate__animated animate__bounceIn copilot-view copilot-view-step-{{te?.step}}\">\n    <ng-container *ngTemplateOutlet=\"te?.template\"></ng-container>\n  </div>\n\n</div>\n",
        styles: [".ngx-wrapper-overview{display:none;position:fixed;z-index:9999;width:100%;height:100%;top:0;left:0;background-color:rgba(255,255,255,.7)}.ngx-wrapper-overview .copilot-view{position:fixed;max-width:300px;max-height:-webkit-min-content;max-height:-moz-min-content;max-height:min-content;padding:10px;border-radius:10px;background-color:#6b66ff;color:#fff;display:none}.ngx-copilot-pulse{display:block;border-radius:50%;background:#cca92c;cursor:pointer;box-shadow:0 0 0 rgba(204,169,44,.8);animation:2s infinite ngx-copilot-pulse}.ngx-copilot-pulse:hover{animation:none}@keyframes ngx-copilot-pulse{0%{box-shadow:0 0 0 0 rgba(204,169,44,.4)}70%{box-shadow:0 0 0 10px rgba(204,169,44,0)}100%{box-shadow:0 0 0 0 rgba(204,169,44,0)}}"]
    })
], NgxWrapperCopilotComponent);

let NgxCopilotModule = class NgxCopilotModule {
};
NgxCopilotModule = __decorate([
    NgModule({
        declarations: [NgxCopilotComponent, CopilotDirective, NgxWrapperCopilotComponent],
        imports: [
            CommonModule
        ],
        exports: [NgxCopilotComponent, CopilotDirective, NgxWrapperCopilotComponent]
    })
], NgxCopilotModule);

/*
 * Public API Surface of ngx-copilot
 */

/**
 * Generated bundle index. Do not edit.
 */

export { CopilotDirective, NgxCopilotComponent, NgxCopilotModule, NgxCopilotService, NgxWrapperCopilotComponent };
//# sourceMappingURL=ngx-copilot.js.map
