import { __decorate } from 'tslib';
import { EventEmitter, ɵɵdefineInjectable, Output, Injectable, Component, ElementRef, Input, Directive, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';

var NgxCopilotService = /** @class */ (function () {
    function NgxCopilotService() {
        var _this = this;
        this.template = new EventEmitter();
        this.nextEmit = new EventEmitter();
        this.getParent = function () {
            try {
                var wrapper = document.querySelector(".ngx-wrapper-overview");
                wrapper.style.display = 'block';
                var copilotsElement = document.querySelectorAll(".ngx-copilot-init");
                Array.from(copilotsElement).map(function (e) {
                    var order = e.getAttribute('data-step');
                    if (order) {
                        _this.find(order);
                        var el = e.getBoundingClientRect();
                        var single = document.querySelector(".copilot-view-step-" + order);
                        var top_1 = el.top, right = el.right, left = el.left, bottom = el.bottom, width = el.width;
                        single.style.marginLeft = width + "px";
                        single.style.top = top_1 + "px";
                        single.style.right = right + "px";
                        single.style.bottom = bottom + "px";
                        single.style.left = left + "px";
                    }
                });
            }
            catch (e) {
                return null;
            }
        };
        this.getTemplates = function () {
            try {
                _this.elementsDomActive = document.querySelectorAll(".copilot-view.copilot-active");
                _this.elementsDom = document.querySelectorAll(".copilot-view");
                if (!(_this.elementsDomActive.length)) {
                    _this.find(1);
                }
            }
            catch (e) {
                return null;
            }
        };
        this.checkInit = function () {
            setTimeout(function () {
                _this.getParent();
                _this.getTemplates();
            }, 60);
        };
        this.removeWrapper = function () {
            try {
                var body = document.querySelector("body");
                var wrapper = document.querySelector(".ngx-wrapper-overview");
                var list = document.querySelector(".copilot-view");
                var listParent = document.querySelectorAll(".ngx-copilot-init");
                Array.from(listParent).map(function (e) {
                    console.log(e);
                    e.style.backgroundColor = 'initial';
                });
                Array.from(list).map(function (e) {
                    e.style.display = "none";
                });
                body.classList.remove('ngx-copilot-active');
                wrapper.style.display = 'none';
            }
            catch (e) {
                return null;
            }
        };
        this.find = function (order) {
            if (order === void 0) { order = null; }
            try {
                var wrapper_1 = document.querySelector("body");
                Array.from(_this.elementsDom).map(function (e) {
                    var o = e.getAttribute('step');
                    var single = document.querySelector(".ngx-copilot-init[data-step='" + o + "']");
                    if ("" + order === o) {
                        single.style.backgroundColor = '#cfceff';
                        single.classList.add('ngx-copilot-pulse');
                        wrapper_1.classList.add('ngx-copilot-active');
                        wrapper_1.classList.add("ngx-copilot-active-step-" + o);
                        e.style.display = "block";
                    }
                    else {
                        wrapper_1.classList.remove("ngx-copilot-active-step-" + o);
                        single.style.backgroundColor = 'initial';
                        single.classList.remove('ngx-copilot-pulse');
                        // wrapper.classList.remove('ngx-copilot-active')
                        e.style.display = "none";
                    }
                });
            }
            catch (e) {
                return null;
            }
        };
        this.next = function (data) {
            if (data === void 0) { data = null; }
            _this.nextEmit.emit(data);
        };
    }
    NgxCopilotService.ɵprov = ɵɵdefineInjectable({ factory: function NgxCopilotService_Factory() { return new NgxCopilotService(); }, token: NgxCopilotService, providedIn: "root" });
    __decorate([
        Output()
    ], NgxCopilotService.prototype, "template", void 0);
    __decorate([
        Output()
    ], NgxCopilotService.prototype, "nextEmit", void 0);
    NgxCopilotService = __decorate([
        Injectable({
            providedIn: 'root'
        })
    ], NgxCopilotService);
    return NgxCopilotService;
}());

var NgxCopilotComponent = /** @class */ (function () {
    function NgxCopilotComponent() {
    }
    NgxCopilotComponent.prototype.ngOnInit = function () {
    };
    NgxCopilotComponent = __decorate([
        Component({
            selector: 'lib-ngx-copilot',
            template: "\n    <p>\n      ngx-copilot works!\n    </p>\n  "
        })
    ], NgxCopilotComponent);
    return NgxCopilotComponent;
}());

var CopilotDirective = /** @class */ (function () {
    function CopilotDirective(service, elem) {
        this.service = service;
        this.elem = elem;
    }
    CopilotDirective.prototype.ngOnInit = function () {
    };
    CopilotDirective.prototype.ngOnDestroy = function () {
        this.service.template.unsubscribe();
    };
    CopilotDirective.prototype.ngAfterViewInit = function () {
        if (this.template) {
            this.elem.nativeElement.classList.add('ngx-copilot-init');
            if (this.step) {
                this.elem.nativeElement.dataset.step = this.step;
                this.service.template.emit({
                    step: this.step,
                    template: this.template
                });
            }
        }
    };
    CopilotDirective.ctorParameters = function () { return [
        { type: NgxCopilotService },
        { type: ElementRef }
    ]; };
    __decorate([
        Input('copilot-step')
    ], CopilotDirective.prototype, "step", void 0);
    __decorate([
        Input('copilot-template')
    ], CopilotDirective.prototype, "template", void 0);
    CopilotDirective = __decorate([
        Directive({
            selector: '[copilot]'
        })
    ], CopilotDirective);
    return CopilotDirective;
}());

var NgxWrapperCopilotComponent = /** @class */ (function () {
    function NgxWrapperCopilotComponent(service) {
        this.service = service;
        this.viewTemplate = [];
    }
    NgxWrapperCopilotComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.service.template.subscribe(function (a) {
            _this.viewTemplate.push(a);
        });
        this.service.nextEmit.subscribe(function (next) { return _this.service.find(next); });
    };
    NgxWrapperCopilotComponent.prototype.ngAfterViewInit = function () {
        setTimeout(function () {
        }, 50);
    };
    NgxWrapperCopilotComponent.ctorParameters = function () { return [
        { type: NgxCopilotService }
    ]; };
    NgxWrapperCopilotComponent = __decorate([
        Component({
            selector: 'ngx-wrapper-copilot',
            template: "<div class=\"ngx-wrapper-overview animate__animated animate__fadeIn\">\n  <div *ngFor=\"let te of viewTemplate\" [attr.step]=\"te?.step\"\n       class=\"animate__animated animate__bounceIn copilot-view copilot-view-step-{{te?.step}}\">\n    <ng-container *ngTemplateOutlet=\"te?.template\"></ng-container>\n  </div>\n\n</div>\n",
            styles: [".ngx-wrapper-overview{display:none;position:fixed;z-index:9999;width:100%;height:100%;top:0;left:0;background-color:rgba(255,255,255,.7)}.ngx-wrapper-overview .copilot-view{position:fixed;max-width:300px;max-height:-webkit-min-content;max-height:-moz-min-content;max-height:min-content;padding:10px;border-radius:10px;background-color:#6b66ff;color:#fff;display:none}.ngx-copilot-pulse{display:block;border-radius:50%;background:#cca92c;cursor:pointer;box-shadow:0 0 0 rgba(204,169,44,.8);animation:2s infinite ngx-copilot-pulse}.ngx-copilot-pulse:hover{animation:none}@keyframes ngx-copilot-pulse{0%{box-shadow:0 0 0 0 rgba(204,169,44,.4)}70%{box-shadow:0 0 0 10px rgba(204,169,44,0)}100%{box-shadow:0 0 0 0 rgba(204,169,44,0)}}"]
        })
    ], NgxWrapperCopilotComponent);
    return NgxWrapperCopilotComponent;
}());

var NgxCopilotModule = /** @class */ (function () {
    function NgxCopilotModule() {
    }
    NgxCopilotModule = __decorate([
        NgModule({
            declarations: [NgxCopilotComponent, CopilotDirective, NgxWrapperCopilotComponent],
            imports: [
                CommonModule
            ],
            exports: [NgxCopilotComponent, CopilotDirective, NgxWrapperCopilotComponent]
        })
    ], NgxCopilotModule);
    return NgxCopilotModule;
}());

/*
 * Public API Surface of ngx-copilot
 */

/**
 * Generated bundle index. Do not edit.
 */

export { CopilotDirective, NgxCopilotComponent, NgxCopilotModule, NgxCopilotService, NgxWrapperCopilotComponent };
//# sourceMappingURL=ngx-copilot.js.map
